<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01//EN" "http://www.w3.org/TR/html4/strict.dtd">
<html>
<head>
              <meta http-equiv="Content-Type" content="text/html; charset=UTF-8">
              <title>Temperatury w Perkozie - 2013</title>
           
<script type="text/javascript" src="http://ajax.googleapis.com/ajax/libs/jquery/1.7.1/jquery.min.js"></script>              
<script src="http://code.highcharts.com/highcharts.js"></script>


<?php
//Pobieram dane z pliku downld02.txt
$dane =file("http://meteo24.nazwa.pl/olsztynek_perkoz/downld02.txt");	//ścieżka pełna jeśli dane są na innym serwerze
$dane = preg_replace('/(\s{2,})/', '|', $dane);  //Wielokrotne spcje między parametrami zamieniam na "|"

for ($i=3;$i<count($dane);$i++)  //zliczam wiersze od 4-go (pierwszy to $i=0)
   {
   $param =explode("|",$dane[$i]); 	//rozbijam na parametry/kolumny po znaczniku "|"
   //ustawiam serie kolejnych parametrów, przecinek rozdziela wartości
   $data .= $param[0] .",";		// data (yy-mm-dd)
   $godz .= $param[1] .",";		// godzina (hh:ii)
   $Temp .= $param[2]  .",";		// temperatura
   $Hum .= $param[5]  .",";		// wilgotność
   $DewPt .= $param[6]  .",";		// punkt rosy
   $WSpeed .= $param[7]  .",";		// prędkość wiatru uśredniona
   $HiWSpeed .= $param[10]  .",";	// prędkość wiatru w porywach
   $Bar .= $param[16]  .",";		// ciśnienie
   $Rain .= $param[17]  .",";		// deszcz (opady)
   $RainRate .= $param[18]  .",";	// intensywność opadu
   $Solar .= $param[19]  .",";		// promieniowanie słoneczne
   $UVindex .= $param[22]  .",";	// index promieniowania UV
   }

/*** Usuwam przcinek po ostatniej wartości 
- w większości przypadków Highcharts zignoruje brak liczby po ostatnim przecinku
ale dla pewności lepiej to zrobić ***/
   $Temp =  substr ($Temp, 0, -1);
   $Hum =  substr ($Hum, 0, -1);
   $DewPt =  substr ($DewPt, 0, -1);
   $WSpeed =  substr ($WSpeed, 0, -1);
   $HiWSpeed =  substr ($HiWSpeed, 0, -1);
   $Bar =  substr ($Bar, 0, -1);
   $Rain =  substr ($Rain, 0, -1);
   $RainRate =  substr ($RainRate, 0, -1);
   $Solar =  substr ($Solar, 0, -1);
   $UVindex =  substr ($UVindex, 0, -1);
   	
//Ustawiam datę początkową
$start = substr ($data, 0, 8);			//8 znaków z początku
$UData = strtotime ("$start 01:10:00")*1000;	//czas w formacie uniksowym w milisekundach przesunięty o godzinę
/*** DO sprawdzenia - dlaczego Highcharts odczytuje z godzinnym przesunięciem?  Może chodzi o czas stefowy? ***/

// odczytuję godzinę ostatniego pomiaru
$end = substr ($godz, -6, -1);			//5 znaków z końca
$end = preg_replace('/,/', '0', $end);		//jeśli godzina 1-cyfrowa to załapuje się przecinek przed cyfrą, więc zamieniam go na "0"

?>

<script type="text/javascript">
$(document).ready(function() {		
//  Opcje językowe ==============
Highcharts.setOptions({
	lang: {
        resetZoom: 'Cofnij',
        resetZoomTitle: 'Kliknij by zobaczyć cały wykres',
        months: ['Styczeń', 'Luty', 'Marzec', 'Kwiecień', 'Maj', 'Czerwiec', 'Lipiec', 'Sierpień', 'Wrzesień', 'Październik', 'Listopad', 'Grudzień'],
        shortMonths: ['Sty', 'Luty', 'Marz', 'Kwie', 'Maj', 'Cze', 'Lip', 'Sie', 'Wrz', 'Paźdz', 'Lis', 'Gru'],
        weekdays: ['Niedziela', 'Poniedziałek', 'Wtorek', 'Środa', 'Czwartek', 'Piątek', 'Sobota']
	}
});

/***  Wygląd i opcje wspólne dla wykresów  - warto ustawić dla oszczędności kodu
ale można też definiować dla każdego wykresu odrębnie ***/

Highcharts.theme = {
   chart: {
      backgroundColor: '#FFFFFF',
      borderColor: '#FFFF99',
      borderWidth: 1,
      shadow: true,
      plotBackgroundColor: "#FFFF99",
      plotShadow: false,
      margin: [35,25,25,40]	// top, right, bottom, left
      },
   title: {
      style: {
         	color: "#000",
         	font: 'bold 12px "Trebuchet MS", Verdana, sans-serif'
      	     }
      },
      credits: {
	enabled: false
      },
      legend: {
        enabled: false
      },
      xAxis: {
        labels: {
             style: {color: '#000000'}
            	},
        gridLineWidth: 1,
        gridLineDashStyle: 'longdash'
      },
      yAxis: {
        minorGridLineDashStyle: 'ShortDash',
        minorTickInterval: 'auto',
        minorTickLength: 7,
        minorTickWidth: 3,
      	tickWidth: 1,
      	labels: {
             style: {color: '#000000'}
            	},
      	tickColor: "#000"
      },
      tooltip: {
       dateTimeLabelFormats:{hour:"%A, %e %B, %H:%M"}
      },
      plotOptions: {
        series: {
          marker: {
            enabled: false,
              states: {
                hover: {
                   enabled: true
                       }
                      }
                  }
                }
      }
 };
// Apply the theme
var highchartsOptions = Highcharts.setOptions(Highcharts.theme);
	
//Wykres temperatury i punktu rosy ============
        Tempchart = new Highcharts.Chart({	
       	chart: {
                renderTo: 'divTemp',
                type: 'spline',
                zoomType: 'x'
            },
            title: {
                text: 'Temperatura i punk rosy - zmiany od 00:10 wczoraj do <?php echo "$end"; ?> dziś'

            },
            subtitle: {
                text: ''
            },
            
            xAxis: {
                type: 'datetime',
                maxZoom: 2 * 3600000, // 2 godziny
                title: {
                    text: null
                }
            },
            yAxis: {
                title: {
                    text: null //'Temperatura [°C]'
                }
            },
            tooltip: {
                shared: true,
                valueSuffix: ' °C'
                
            },
               
            series: [{
                name: 'Temperatura',
                color: '#BF0B23',	//jeśli kolor nie jest określony to stosowane są kolory domyślne
                pointInterval: 600 * 1000,
                pointStart: <?php echo "$UData"; ?>, 
                data: [<?php echo "$Temp"; ?>]
            },{
                name: 'Punkt rosy',
                pointInterval: 600 * 1000,
                pointStart: <?php echo "$UData"; ?>, 
                data: [<?php echo "$DewPt"; ?>]
            }]
	});
//Wykres wilgotności ============
	Humchart = new Highcharts.Chart({	
       	chart: {
                renderTo: 'divHum',
                zoomType: 'x'
            },
            title: {
                text: 'Wilgotność - zmiany od 00:10 wczoraj do <?php echo "$end"; ?> dziś'

            },
            subtitle: {
                text: ''
            },
            
            xAxis: {
                type: 'datetime',
                maxZoom: 2 * 3600000, // 2 godziny
                title: {
                    text: null
                }
            },
            yAxis: {
                title: {
                    text: null //'Wilgotność [%]'
                },
                max: 100,
                min: 0
                
            },
            tooltip: {
                valueSuffix: ' %'
            },
               
            series: [{
                name: 'Wilgotność',
                type: 'areaspline',
                lineWidth: 1,
                fillOpacity: 0.5,
                pointInterval: 600 * 1000,
                pointStart: <?php echo "$UData"; ?>, 
                data: [<?php echo "$Hum"; ?>]
            }]
        });


//Wykres promieniowania słonecznego ============
	Solchart = new Highcharts.Chart({	
       	chart: {
                renderTo: 'divSol',
                zoomType: 'x'
            },
            title: {
                text: 'Promieniowanie słoneczne - od 00:10 wczoraj do <?php echo "$end"; ?> dziś'
	    },
            subtitle: {
                text: ''
            },
            xAxis: {
                type: 'datetime',
                maxZoom: 2 * 3600000, // 2 godziny
                title: {
                    text: null
                }
            },
            yAxis: {
                title: {
                    text: null //'Wilgotność [W/m2]'
                },
                min: 0
            },
            tooltip: {
                valueSuffix: ' W/m2'
            },
            series: [{
                name: 'Promieniowanie',
                type: 'areaspline',
                lineWidth: 1,
                color: '#F2CD24',
                pointInterval: 600 * 1000,
                pointStart: <?php echo "$UData"; ?>, 
                data: [<?php echo "$Solar"; ?>]
            }]
        }); 
       	
    });
</script>

</head>
<body>

<div id="divTemp" style="width: 650px; height: 350px; margin: 0 auto"></div>

<div id="divHum" style="width: 550px; height: 250px; margin: 0 auto"></div>

<div id="divSol" style="width: 300px; height: 200px; margin: 0 auto"></div>

</body>
</html>

 

